<?php

class DZSPRS {
  public $db_main_options = '';
  public $index = 0;
  public $base_url;
  public $shortcode = 'advancedtabs';
  public $alwaysembed = 'off';
  public $pluginmode = "plugin";
  public $lastskin = '';
  private $can_session = true;
  public $capability_admin = 'manage_options';
  private $adminpagename_mainoptions = 'dzsprs-mo';
  private $dbname_main_options = 'dzsprs-mo';

  function __construct() {
    $this->base_url = plugins_url('', __FILE__) . '/';
//        $this->main_options = get_option('dzsat_options');

    if (function_exists('session_status') && function_exists('session_start')) {


      if (session_status() == PHP_SESSION_NONE) {
        session_start();
      }
    } else {
      $this->can_session = false;
    }


    add_action('wp_ajax_dzsprs_test', array($this, 'ajax_test'));


    add_action('init', array($this, 'handle_init'));
    add_action('admin_menu', array($this, 'handle_admin_menu'));
    add_action('admin_head', array($this, 'handle_admin_head'));

    add_shortcode('parallax_showcase_item', array($this, 'shortcode_item'));
    add_shortcode('parallax_showcase', array($this, 'shortcode_main'));

    $db_main_options_default = array(
      'debug_enabled' => false,
      'debug_enabled_config' => false,
      'debug_enabled_display' => false,
      'memory_1024' => false,
      'memory_128' => false,
      'max_input_vars_5000' => false,
      'max_execution_time_30' => false,
      'allow_url_fopen' => false,
      'old_limit' => '', // -- the old wp memory limit
    );

    $this->db_main_options = get_option($this->dbname_main_options);

    if (is_array($this->db_main_options) == false) {
      $this->db_main_options = array();
    }

    $this->db_main_options = array_merge($db_main_options_default, $this->db_main_options);

//        print_r($db_main_options);


    $this->check_posts();

    if ($this->db_main_options['max_execution_time_30']) {

      @ini_set('max_execution_time', '31');
    }

    if ($this->db_main_options['max_input_vars_5000']) {

//            echo 'whattt';
      @ini_set('max_input_vars', 5000);
    }

    if ($this->db_main_options['allow_url_fopen']) {

      @ini_set('allow_url_fopen', true);
    }
    if ($this->db_main_options['debug_enabled_display']) {

//            @ini_set('allow_url_fopen', true);

      @ini_set('display_errors', 'On');
      @ini_set('display_errors_startup', 'On');
    }

  }

  function sanitize_id_to_src($arg) {

    //        echo ' arg - '.$arg;
    if (is_numeric($arg)) {

      $imgsrc = wp_get_attachment_image_src($arg, 'full');
      //            print_r($imgsrc);
      //            echo ' $imgsrc - '.$imgsrc;
      return $imgsrc[0];
    } else {
      return $arg;
    }


  }


  function shortcode_item($pargs = array(), $content = '') {
    // -- // [parallax_showcase_item]


    $margs = array(
      'thumb' => '',
      'title' => '',
      'subtitle' => '',
      'side_color' => '#ff0000',
    );


  }


  function shortcode_main($pargs = array(), $content = '') {


    //[parallax_showcase template="template-simple" feed="woocommerce" count="6" js_breakout="off" custom_ph="123px"]

    $margs = array(
      'template' => 'template-simple',
      'feed' => 'normal',
      'count' => '5',
      'items_data' => '',
      'items' => '',
      'cat' => '',
      'js_breakout' => 'off',
      'custom_ph' => '',
    );

    $margs = array_merge($margs, $pargs);

    $fout = '';

//        print_r($margs);


    $fout .= '<div class="';
    $fout .= ' dzsparallax-showcase auto-init navigation-offset-80';

    $fout .= ' ' . $margs['template'];

    if ($margs['template'] == 'template-side' || $margs['template'] == 'template-mobile') {
      $fout .= ' transition-longer-longer-fadeout';
    }

    if ($margs['template'] == 'template-bal') {
      $fout .= ' theme-dark';
    }

    $fout .= '"  data-options=\'{
    "init":"on" ';
    if ($margs['template'] == 'template-bal' || $margs['template'] == 'template-hip') {
      $fout .= ',"navigation":"numbers"';
    }
    if ($margs['js_breakout']) {
      $fout .= ',"js_breakout":"' . $margs['js_breakout'] . '"';
    }
    if ($margs['custom_ph']) {
      $fout .= ',"custom_ph":"' . $margs['custom_ph'] . '"';
    }


    $fout .= '}\'';


    $fout .= '>';


    $fout .= '<div class="parallax-feature-pages">';


    $its = array();
    if (isset($margs['vc_items'])) {

      $vc_items = vc_param_group_parse_atts($margs['vc_items']);


      if (is_array($vc_items)) {

        foreach ($vc_items as $arrit) {


          $aux = array(
            'thumb' => '',
          );

//                    print_r($arrit);
          $aux = array_merge($aux, $arrit);


          $aux['content'] = $aux['the_content'];
          array_push($its, $aux);

        }
      }
    }


//            echo ' content - (('.$content.'))';


    if ($margs['feed'] == 'normal' && count($its) == 0) {
//                $arr = array();


      $margs['items_data'] = str_replace('amp;items', 'items', $margs['items_data']);
//                $margs['items'] = str_replace('items','amp;items',$margs['items'],1);

      parse_str($margs['items_data'], $arr);


//                foreach ($arr['amp;items'] as $lab=>$val){
//
//
//                    if(isset($arr['amp;items'][$lab])){
//                        $arr['items'][$lab] =array_merge($arr['items'][$lab],$arr['amp;items'][$lab]);
//                    }
//
//
//                }

//                $arr['items'] = array_merge($arr['items'],$arr['amp;items']);
//                unset($arr['amp;items']);
//                print_r($arr);


      if (isset($arr['items']) && is_array($arr['items'])) {

        foreach ($arr['items'] as $arrit) {


//                    print_r($arrit);
          $aux = $arrit;

          array_push($its, $aux);

        }
      }
    }


    if ($margs['feed'] == 'woocommerce') {
//                $arr = array();

      $args = array(
        'post_type' => 'product',
        'posts_per_page' => $margs['count'],
        'orderby' => 'date',
        'order' => 'DESC',
      );


      $query = new WP_Query($args);

      foreach ($query->posts as $po) {


        $aux = array(
          'title' => $po->post_title,
          'content' => do_shortcode($po->post_content),
          'subtitle' => do_shortcode(get_post_meta($po->ID, 'subtitle', true)),
          'side_color' => get_post_meta($po->ID, 'side_color', true),
          'thumb' => $this->sanitize_id_to_src(get_post_thumbnail_id($po->ID), 'full'),
        );

        $aux['post_id'] = $po->ID;


        if (isset($po->post_excerpt) && $po->post_excerpt) {
          $aux['content'] = do_shortcode($po->post_excerpt);
        }
        if (function_exists('wc_get_product')) {

          $product = wc_get_product($po->ID);

          $aux['price'] = $product->get_price();


          $currency = get_woocommerce_currency_symbol();

          $aux['price_html'] = $currency . $product->get_price();

        }


        array_push($its, $aux);

      }
    }


    if ($content) {


      $currlab = intval(count($its));


      $output_array = '';
      preg_match_all("/\[parallax_showcase_item.*?\]([\s|\S]*?)\[\/parallax_showcase_item\]/", $content, $output_array);


      if (isset($output_array[0][0])) {
        foreach ($output_array[1] as $lab_ind => $val) {


          $itskey = intval($currlab) + intval($lab_ind);
          $its[$itskey]['content'] = do_shortcode($val);
        }
      }


      $lab_key = 'thumb';

      if (is_int($currlab)) {

      } else {
        $currlab = 0;
      }


      preg_match_all("/\[parallax_showcase_item.*?" . $lab_key . "=\"(.*?)\".*?\]([\s|\S]*?)\[\/parallax_showcase_item\]/", $content, $output_array);


//		    print_r($output_array);
      if (isset($output_array[1][0])) {
        foreach ($output_array[1] as $lab_ind => $val) {


          $itskey = intval($currlab) + intval($lab_ind);
          $its[$itskey][$lab_key] = $this->sanitize_id_to_src($val);
        }
      }


      $lab_key = 'title';


      preg_match_all("/\[parallax_showcase_item.*?" . $lab_key . "=\"(.*?)\".*?\]([\s|\S]*?)\[\/parallax_showcase_item\]/", $content, $output_array);


      if (isset($output_array[1][0])) {
        foreach ($output_array[1] as $lab_ind => $val) {


          $itskey = intval($currlab) + intval($lab_ind);
          $its[$itskey][$lab_key] = $val;
        }
      }

      $lab_key = 'subtitle';


      preg_match_all("/\[parallax_showcase_item.*?" . $lab_key . "=\"(.*?)\".*?\]([\s|\S]*?)\[\/parallax_showcase_item\]/", $content, $output_array);


      if (isset($output_array[1][0])) {
        foreach ($output_array[1] as $lab_ind => $val) {


          $itskey = intval($currlab) + intval($lab_ind);
          $its[$itskey][$lab_key] = $val;
        }
      }


    }


//            print_rr($margs);
//            print_rr($its);
    $ind4 = 0;
    foreach ($its as $it) {

      $auxit = array(
        'thumb' => '',
      );

      $it = array_merge($auxit, $it);

      $ind4 += 1;

      $aux = '';
      if ($margs['template'] == 'template-simple') {
        $aux = '<div class="parallax-feature-page">

            <div class="dzs-container">
            <div class="dzs-row dzs-row-inline">

                <div class="dzs-col-md-6 col-image">
                    <img class="fullwidth feat-img " src="{{thumb}}"/>
                </div>
                <div class="dzs-col-md-6 use-for-scrolling col-text">
                    <div class="desc-block">
                        <h2>{{title}}</h2>
                        {{subtitle_str}}
                        <hr>
                        <div class="paragraph">{{content}}</div>
                    </div>
                </div>
            </div>
            </div>
        </div>';

      }
      if ($margs['template'] == 'template-simple-2') {
        $aux = '<div class="parallax-feature-page">

            <div class="dzs-container">
            <div class="dzs-row dzs-row-inline">';

        if ($ind4 % 2 == 1) {


          $aux .= '<div class="dzs-col-md-6 use-for-scrolling col-text">
                    <div class="desc-block">
                        <h2>Aligator Bag</h2>';

          if (isset($it['price']) && $it['price']) {

            $aux .= '<div class="big-highlight-price">{{price}}</div>';
          }

          $aux .= '
                        <div class="paragraph">{{content}}</div>
                        {{str_add_to_cart}}
                        ';


          $aux .= '
                
                    </div>
                </div>
                <div class="dzs-col-md-6 col-image">
                    <img class="fullwidth feat-img " src="{{thumb}}"/>
                </div>';


        } else {

          $aux .= '<div class="dzs-col-md-6 col-image">
                    <img class="fullwidth feat-img " src="{{thumb}}"/>
                </div>

                <div class="dzs-col-md-6 use-for-scrolling col-text">
                    <div class="desc-block">
                        <h2>{{title}}</h2>
                        {{subtitle_str}}
                        ';

          if (isset($it['price']) && $it['price']) {

            $aux .= '<div class="big-highlight-price">{{price}}</div>';
          }

          $aux .= '
                        <div class="paragraph">{{content}} </div>
                        {{str_add_to_cart}}
                       ';


          $aux .= '
                    </div>
                </div>';
        }


        $aux .= '</div>
            </div>
        </div>';

      }


      if ($margs['template'] == 'template-hip') {
        $aux = '<div class="parallax-feature-page" style=";">



            <div class="dzs-container">
            <div class="dzs-row dzs-row-inline">


                <div class="dzs-col-md-8 transition-in-slideup transition-out-slidedown transition-in-slower-1 ">

                    <img class="center-it maxfullwidth" src="{{thumb}}"/>
                </div>

                <div class="dzs-col-md-4  ">

                    {{content}}

                </div>
            </div>
            </div>

        </div>';

      }


      if ($margs['template'] == 'template-bal') {
        $aux = '<div class="parallax-feature-page" style="background-color: #404040;">



            <div class="dzs-container">
            <div class="dzs-row dzs-row-inline">


                <div class="dzs-col-md-6 transition-in-slideup transition-out-slidedown transition-in-slower-1 ">

                    <img class="center-it maxfullwidth" src="{{thumb}}"/>
                </div>

                <div class="dzs-col-md-6  ">
                    <div class="desc-block transition-in-slideup transition-out-slidedown">
                        <h2>{{title}}</h2>
                        {{subtitle_str}}
                        <hr class="small-hr">
                        <div class="paragraph">
                        {{content}}
                        </div>
                    </div>
                </div>
            </div>
            </div>

        </div>';

      }


      if ($margs['template'] == 'template-hood') {
        $aux = '<div class="parallax-feature-page">

            <div class="transition-out-mask transition-in-mask full-absolute">

                <div class="page-bg divimage" style="background-image: url({{thumb}});"></div>
            </div>


            <div class="dzs-container">
            <div class="dzs-row dzs-row-inline">

                <div class="dzs-col-md-6 ">
                    <div class="desc-block transition-in-slideup transition-out-slidedown">
                        <h2>{{title}}</h2>
                        {{subtitle_str}}
                        <hr class="small-hr">
                        <div class="paragraph">
                        {{content}}
                        </div>
                    </div>
                </div>
                <div class="dzs-col-md-6 ">
                </div>
            </div>
            </div>

        </div>';

      }


      if ($margs['template'] == 'template-mobile') {
        $aux = '<div class="parallax-feature-page" style=";">

            <div class="parallax-bg ';


        if ($ind4 % 2 == 1) {
          $aux .= ' top-half ';
        } else {

          $aux .= ' bottom-half ';
        }

        $aux .= ' transition-in-bg-rotate-down transition-out-bg-rotate-up " style="background-color: #a44645;"></div>


            <div class="dzs-container">
            <div class="dzs-row dzs-row-inline align-normal">';


        if ($ind4 % 2 == 1) {
          $aux .= ' <div class="dzs-col-md-4 col-text fullheight ">
                            <div class="h50ofpage "> </div>
                            <div class="desc-block transition-in-slideup transition-out-slidedown flex-align-inside-center flex-direction-col h50ofpage">
                                <h2>{{title}}</h2>';


          if ($it['subtitle']) {

            $aux .= '<h4 class="transition-out-slidedown transition-in-slideup ">{{subtitle}}</h4>';
          }

          $aux .= '<hr class="small-hr">
                                {{content}}
                            </div>
                        </div>

                        <div class="dzs-col-md-4 transition-in-slideup transition-out-slidedown transition-in-slower-1 col-image ">

                            <img class="center-it maxfullwidth maxheight80vh" src="{{thumb}}"/>
                        </div>


                        <div class="dzs-col-md-4  display-flex-col col-number">

                            <div class="h50ofpage ">

                                <div class="big-highlight-number replace-var">
                                    <span class="center-it">{{pagenr}}</span>
                                </div>
                            </div>
                        </div>';
        } else {

          $aux .= '   <div class="dzs-col-md-4  display-flex-col col-number">

                    <div class="h50ofpage align-flex-bottom ">

                        <div class="big-highlight-number replace-var">
                            <span class="center-it">{{pagenr}}</span>
                        </div>
                    </div>
                </div>

                <div class="dzs-col-md-4 col-image transition-in-slideup transition-out-slidedown transition-in-slower-1 ">

                    <img class="center-it maxfullwidth maxheight80vh" src="{{thumb}}"/>
                </div>

                <div class="dzs-col-md-4 col-text ">
                    <div class="h50ofpage desc-block  transition-in-slideup transition-out-slidedown flex-align-inside-center flex-direction-col">
                        <h2>{{title}}</h2>';


          if ($it['subtitle']) {

            $aux .= '<h4 class="transition-out-slidedown transition-in-slideup ">{{subtitle}}</h4>';
          }

          $aux .= '
                        <hr class="small-hr">
                        <p>{{content}}</p>


    </div>
</div>';

        }


        $aux .= '</div>
            </div>

</div>';

      }


      if ($margs['template'] == 'template-side') {
        $aux = '<div class="parallax-feature-page" style=";">
                <div class="transition-out-mask transition-in-mask full-absolute">
                <div class=" parallax-bg bottom-right bottom-right-1 h100ph" style="background-color: #00a99d; background: linear-gradient(to bottom, {{side_color}} 0%,rgba(0,169,167,0) 100%); ">
                </div>

                </div>
                <div class="transition-in-slower-1 parallax-bg transition-out-slidedown transition-in-slideup bottom-right h80ph" style="background-image: url({{thumb}});"></div>


                <div class="dzs-container">
                    <div class="dzs-row ">

                        <div class="h20ph"></div>
                        <div class="dzs-col-md-12">

                            <div class="big-highlight-number replace-var transition-in-slower-2 transition-out-slidedown transition-in-slideup">
                                <span class="center-it">{{pagenr}}</span>
                            </div>

                            <h1 class="transition-out-slidedown transition-in-slideup">{{title}}</h1>';


        if ($it['subtitle']) {

          $aux .= '<h4 class="transition-out-slidedown transition-in-slideup transition-in-slower-1">{{subtitle}}</h4>';
        }


        $aux .= '<br>
<br>

                            <div class="dzs-row">
                                <div class="col-md-4">
                                    <div class="paragraph transition-in-slower-2 transition-out-slidedown transition-in-slideup">{{content}}
                                    </div>
                                    <br>
                                    <br>
                                    <div class="paragraph transition-in-slower-3 transition-out-slidedown transition-in-slideup">
                                        <i class="fa fa-long-arrow-left custom-parallax-arrow-left"></i> <i class="fa fa-long-arrow-right custom-parallax-arrow-right"></i>
                                    </div>
                                </div>
                            </div>

                        </div>


                    </div>


                </div>
            </div>';

      }


      $aux = str_replace('{{thumb}}', $this->sanitize_id_to_src($it['thumb']), $aux);
      $aux = str_replace('{{title}}', $it['title'], $aux);
      if (isset($it['subtitle']) && $it['subtitle']) {

//		        $aux=str_replace('{{subtitle}}','<h4 class="subtitle">'.$it['subtitle'].'</h4>',$aux);
        $aux = str_replace('{{subtitle}}', $it['subtitle'], $aux);
      }
      $aux = str_replace('{{subtitle}}', '', $aux);

      if (isset($it['subtitle']) && $it['subtitle']) {

        $aux = str_replace('{{subtitle_str}}', '<h4 class="subtitle">' . $it['subtitle'] . '</h4>', $aux);

      }
      $aux = str_replace('{{subtitle_str}}', '', $aux);

      if (isset($it['side_color']) && $it['side_color']) {

        $aux = str_replace('{{side_color}}', $it['side_color'], $aux);
      }
      $aux = str_replace('{{side_color}}', '', $aux);

      $aux = str_replace('{{content}}', $it['content'], $aux);

      if (isset($it['price']) && $it['price']) {
        $aux = str_replace('{{price}}', $it['price_html'], $aux);


        $aux_add_to_cart = '';

        $aux_add_to_cart .= '<div class="add-to-cart-con">';
        $aux_add_to_cart .= '<form action="" class="cart" method="get" enctype="multipart/form-data">';
        //                            $iout .= woocommerce_quantity_input( array(), $product, false );
        $aux_add_to_cart .= '<input type="hidden" name="add-to-cart" value="' . $it['post_id'] . '"/>';
        $aux_add_to_cart .= '<button class="add-to-cart-btn dzs-button style-border-outside" type="submit" class="button alt">' . esc_html(__("Buy now")) . '</button>';
        $aux_add_to_cart .= '</form>';
        $aux_add_to_cart .= '</div>';

        $aux = str_replace('{{str_add_to_cart}}', $aux_add_to_cart, $aux);
      } else {

      }
      $aux = str_replace('{{price}}', '', $aux);
      $aux = str_replace('{{str_add_to_cart}}', '', $aux);


      $fout .= $aux;
    }


    $fout .= '</div>';


    $fout .= '</div><!-- end parallax-showcase-->';


    $fout .= '';


    /*
    $fout.='    <div class=" dzsparallax-showcase auto-init template-simple transition-longer-longer-fadeout navigation-offset-80" style=\'background-color: #e6e0e0; \' data-options=\'{
"js_breakout":"on"
,"navigation":"numbers"
}\'>

    <div class="parallax-feature-pages">
    <div class="parallax-feature-page">

        <div class="transition-out-mask transition-in-mask full-absolute">

            <div class="page-bg divimage" style="background-image: url(https://localhost:8888/parallax-showcase/source/img/hoodie1.jpg);"></div>
        </div>


        <div class="dzs-container">
        <div class="dzs-row dzs-row-inline">

            <div class="dzs-col-md-6 ">
                <div class="desc-block transition-in-slideup transition-out-slidedown">
                    <h2>Drawstring hood</h2>
                    <hr class="small-hr">
                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. </p>
                    <div class="paragraph">
                    <div class="dzs-button style-border-outside">
                        <span class="the-bg"></span>
                        <span class="the-text">GET NOW</span>
                    </div>
                    </div>
                </div>
            </div>
            <div class="dzs-col-md-6 ">
            </div>
        </div>
        </div>

    </div>

    <div class="parallax-feature-page">
        <div class="transition-out-mask transition-in-mask full-absolute">
        <div class="page-bg divimage" style="background-image: url(https://localhost:8888/parallax-showcase/source/img/hoodie2.jpg);"></div>
        </div>

        <div class="dzs-container">
        <div class="dzs-row dzs-row-inline">

            <div class="dzs-col-md-6 ">
                <div class="desc-block transition-in-slideup transition-out-slidedown">
                    <h2>Half-zip fastening</h2>
                    <hr class="small-hr">
                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. </p>
                </div>
            </div>
            <div class="dzs-col-md-6 ">
            </div>
        </div>
        </div>

    </div>

    <div class="parallax-feature-page">
        <div class="transition-out-mask transition-in-mask full-absolute">
        <div class="page-bg divimage" style="background-image: url(https://localhost:8888/parallax-showcase/source/img/hoodie3.jpg);"></div>
        </div>

        <div class="dzs-container">
        <div class="dzs-row dzs-row-inline">

            <div class="dzs-col-md-6  ">
                <div class="desc-block transition-in-slideup transition-out-slidedown">
                    <h2>Pouch pocket</h2>
                    <hr class="small-hr">
                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. </p>
                </div>
            </div>
            <div class="dzs-col-md-6 ">
            </div>
            </div>
        </div>

    </div>
    </div>

</div>
';

    */

    wp_enqueue_script('dzsprs', $this->base_url . 'dzsparallaxshowcase/dzsparallaxshowcase.js');
    wp_enqueue_style('dzsprs', $this->base_url . 'dzsparallaxshowcase/dzsparallaxshowcase.css');

    return $fout;


  }

  function ajax_test() {

    echo 'ceva';

    print_r($_POST);


    $params = array();
    parse_str($_POST['postdata'], $params);

    print_r($params);
    die();
  }

  function generate_token($id = '') {


    if (!isset($_SESSION[$id])) {
      $token_id = md5(substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 10));
      $_SESSION[$id] = $token_id;
      return $_SESSION[$id];
    }
    return $_SESSION[$id];
  }


  function check_posts() {
    $base = dirname(dirname(dirname(dirname(__FILE__))));
    $base_content = (dirname(dirname(dirname(__FILE__))));


    $file_cont = '';


    $wp_debug_path = $base . '/wp-config.php';
    if (file_exists($wp_debug_path)) {
      $file_cont = file_get_contents($wp_debug_path);
    }


    $log_path = $base_content . '/debug.log';
//        print_r($_POST);


    if (isset($_GET['action']) && $_GET['action'] == 'download_debug_data') {

      header('Content-Type: text/txt');

// It will be called downloaded.pdf
      header('Content-Disposition: attachment; filename="log.log"');

// The PDF source is in original.pdf
      if (file_exists($log_path)) {
        readfile($log_path);
      }
      die();
    }


    if (isset($_GET['action']) && $_GET['action'] == 'delete_debug_data') {


      if (file_exists($log_path)) {
        unlink($log_path);
      }

    }


    if ($this->db_main_options['debug_enabled']) {

//            if(defined("WP_DEBUG")==false){
//                define('WP_DEBUG', true);
////            define('WP_DEBUG', 'alceva');
//                define('WP_DEBUG_LOG', true);
//                define('WP_DEBUG_DISPLAY', false);
//            }


//            echo 'hmm';
    } else {

      if (defined("WP_DEBUG") == false) {
//                define('WP_DEBUG', false);
      }


    }


    if (isset($_POST['action'])) {

      $nonce_lab = 'nonce_dzsprs';

      if (isset($_POST[$nonce_lab])) {
        if ($this->can_session == false || isset($_SESSION[$nonce_lab]) && $_POST[$nonce_lab] == $_SESSION[$nonce_lab]) {


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_debug') {


//                        define('WP_DEBUG', true);
//                        define('WP_DEBUG_LOG', true);
//                        define('WP_DEBUG_DISPLAY', false);


            ini_set('display_errors', 0);
            ini_set('log_errors', 1);
            ini_set('error_log', dirname(dirname(dirname(__FILE__))) . '/debug.log');
            ini_set('error_reporting', E_ALL ^ E_NOTICE);


            $this->db_main_options['debug_enabled'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_debug') {

//                        define('WP_DEBUG', false);


            ini_set('display_errors', 0);
            ini_set('log_errors', 0);

            $this->db_main_options['debug_enabled'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_debug_display') {

//                        define('WP_DEBUG', false);


            ini_set('display_errors', 0);
            ini_set('log_errors', 0);

            $this->db_main_options['debug_enabled_display'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_debug_display') {

//                        define('WP_DEBUG', false);


//                        ini_set('display_errors', 0);
//                        ini_set('log_errors', 0);

            $this->db_main_options['debug_enabled_display'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_debug_config') {


            if ($file_cont) {

              preg_match_all("/define\(.*?['|\"]WP_DEBUG['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_DEBUG['|\"].*?,.*?)(.*?)\)/", "$1true)", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_DEBUG\', true); require_once', $file_cont);
              }


              preg_match_all("/define\(.*?['|\"]WP_DEBUG_LOG['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_DEBUG_LOG['|\"].*?,.*?)(.*?)\)/", "$1true)", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_DEBUG_LOG\', true); require_once', $file_cont);
              }


              preg_match_all("/define\(.*?['|\"]WP_DEBUG_DISPLAY['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_DEBUG_DISPLAY['|\"].*?,.*?)(.*?)\)/", "$1false)", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_DEBUG_DISPLAY\', false); require_once', $file_cont);
              }
            }


            echo $file_cont;


            file_put_contents($wp_debug_path, $file_cont);

            error_log("Hmm");


            $this->db_main_options['debug_enabled_config'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_debug_config') {


            if ($file_cont) {

              preg_match_all("/define\(.*?['|\"]WP_DEBUG['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);

//                print_r($output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_DEBUG['|\"].*?,.*?)(.*?)\)/", "$1false)", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_DEBUG\', false); require_once', $file_cont);
              }


            }


//                        echo $file_cont;


            file_put_contents($wp_debug_path, $file_cont);

            error_log("Hmm disabled");

            $this->db_main_options['debug_enabled_config'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_memory_1024') {


            @ini_set('memory_limit', '1024M');
            if ($file_cont) {

              preg_match_all("/define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?)(.*?)\)/", "$1'1024M')", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_MEMORY_LIMIT\', "1024M"); require_once', $file_cont);
              }


            }


            echo $file_cont;


            file_put_contents($wp_debug_path, $file_cont);

            error_log("Hmm");


            $this->db_main_options['memory_1024'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_memory_1024') {


            @ini_set('memory_limit', '512M');


            if ($file_cont) {

              preg_match_all("/define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);

//                print_r($output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?)(.*?)\)/", "$1'512M')", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_MEMORY_LIMIT\', \'512M\'); require_once', $file_cont);
              }


            }


//                        echo $file_cont;


            file_put_contents($wp_debug_path, $file_cont);

            error_log("Hmm disabled memory 1024");

            $this->db_main_options['memory_1024'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_memory_128') {


            @ini_set('memory_limit', '128M');
            if ($file_cont) {

              preg_match_all("/define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?)(.*?)\)/", "$1'128M')", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_MEMORY_LIMIT\', "128M"); require_once', $file_cont);
              }


            }


            echo $file_cont;


            file_put_contents($wp_debug_path, $file_cont);

            error_log("Hmm");


            $this->db_main_options['memory_128'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_max_execution_time_30') {


            @ini_set('max_execution_time', '31');


            error_log("Hmm");


            $this->db_main_options['max_execution_time_30'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }
          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_max_input_vars_5000') {


            @ini_set('max_input_vars', 5000);


            $f = fopen(dirname(dirname(dirname(dirname(__FILE__)))) . '/.htaccess', "a+");
            fwrite($f, '
php_value max_input_vars 5001
php_value suhosin.get.max_vars 5001
php_value suhosin.post.max_vars 5001
php_value suhosin.request.max_vars 5001');
            fclose($f);

            error_log("Hmm");


            $this->db_main_options['max_input_vars_5000'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_enable_allow_url_fopen') {


            @ini_set('allow_url_fopen', true);


            error_log("Hmm");


            $this->db_main_options['allow_url_fopen'] = true;
            update_option($this->dbname_main_options, $this->db_main_options);

          }

          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_allow_url_fopen') {


            error_log("Hmm");


            $this->db_main_options['allow_url_fopen'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_max_execution_time_30') {


            error_log("Hmm");


            $this->db_main_options['max_execution_time_30'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_max_input_vars_5000') {


            error_log("Hmm");


            $this->db_main_options['max_input_vars_5000'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


          if (isset($_POST['action']) && $_POST['action'] == 'dzsprs_disable_memory_128') {


            @ini_set('memory_limit', '512M');


            if ($file_cont) {

              preg_match_all("/define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?(.*?)\)/", $file_cont, $output_array);

//                print_r($output_array);


              if (count($output_array[0])) {
                $file_cont = preg_replace("/(define\(.*?['|\"]WP_MEMORY_LIMIT['|\"].*?,.*?)(.*?)\)/", "$1'512M')", $file_cont);
              } else {


                $file_cont = str_replace('require_once', ' define(\'WP_MEMORY_LIMIT\', \'512M\'); require_once', $file_cont);
              }


            }


//                        echo $file_cont;


            file_put_contents($wp_debug_path, $file_cont);

            error_log("Hmm disabled memory 128");

            $this->db_main_options['memory_128'] = false;
            update_option($this->dbname_main_options, $this->db_main_options);

          }


        } else {
          echo('nonce not correct');
        }
      }
    }

//            print_r($_POST);
//            print_r($_SESSION);
  }


  function handle_init() {
    wp_enqueue_script('jquery');

    if (is_admin()) {
      if (current_user_can('edit_posts') || current_user_can('edit_pages')) {
        if (get_user_option('rich_editing') == 'true') {
        }
      }

      wp_enqueue_script('dzsprs-admin-global', $this->base_url . 'assets/admin-global.js');
      wp_enqueue_style('dzsprs-admin-global', $this->base_url . 'assets/admin-global.css');
      if (isset($_GET['page']) && $_GET['page'] == $this->adminpagename_mainoptions) {
        wp_enqueue_script('dzsprs-mo', $this->base_url . 'assets/admin-mo.js');
      }


      if (isset($_GET['dzsprs_shortcode_generator']) && $_GET['dzsprs_shortcode_generator'] == 'on') {
        //            dzsprx_shortcode_builder();

        include_once('shortcodegenerator/shortcode-generator.php');
        wp_enqueue_script('dzsprs-sg', $this->base_url . 'shortcodegenerator/shortcode-generator.js');
        wp_enqueue_style('dzsprs-sg', $this->base_url . 'shortcodegenerator/shortcode-generator.css');
        wp_enqueue_style('dzssel', $this->base_url . 'libs/dzsselector/dzsselector.css');
        wp_enqueue_script('dzssel', $this->base_url . 'libs/dzsselector/dzsselector.js');
        wp_enqueue_style('fontawesome', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css');


        wp_enqueue_script('jquery-sortable');


        wp_enqueue_media();

      }
    }

    include('vc/vc_map.php');
  }

  function handle_admin_head() {

    ?>
    <script>window.dzsprs_settings = {
        translate_add_showcase: "<?php echo __("Add Parallax"); ?>"
        , shortcode_generator_url: "<?php echo admin_url('admin.php?page=dzsprs-mo&dzsprs_shortcode_generator=on'); ?>"
      };</script><?php


    if (current_user_can('edit_posts') || current_user_can('edit_pages')) {


      wp_enqueue_script('ultibox', $this->base_url . 'libs/ultibox/ultibox.js');
      wp_enqueue_style('ultibox', $this->base_url . 'libs/ultibox/ultibox.css');

      wp_enqueue_script('dzsprs_htmleditor', $this->base_url . 'shortcodegenerator/add-buttons-to-editor.js');
      wp_enqueue_script('dzsprs_configreceiver', $this->base_url . 'shortcodegenerator/receiver.js');
    }
  }


  function handle_admin_menu() {


//        echo 'ceva';
    $admin_cap = $this->capability_admin;
    $dzsvcs_page = add_menu_page(__('Parallax Showcase Options ', 'dzsprs'), __('Parallax', 'dzsprs'), $admin_cap, $this->adminpagename_mainoptions, array($this, 'admin_page_mainoptions'), 'div');

  }

  function admin_page_mainoptions() {


    include_once('class_parts/admin-page-mainoptions.php');
    ?>

    <?php
  }


  /**
   * let_to_num function.
   *
   * This function transforms the php.ini notation for numbers (like '2M') to an integer.
   *
   * @param $size
   * @return int
   */
  function wc_let_to_num($size) {
    $l = substr($size, -1);
    $ret = substr($size, 0, -1);
    switch (strtoupper($l)) {
      case 'P':
        $ret *= 1024;
      case 'T':
        $ret *= 1024;
      case 'G':
        $ret *= 1024;
      case 'M':
        $ret *= 1024;
      case 'K':
        $ret *= 1024;
    }
    return $ret;
  }


}