
/*
 * Author: Digital Zoom Studio
 * Website: http://digitalzoomstudio.net/
 * Portfolio: http://codecanyon.net/user/ZoomIt/portfolio
 *
 * Version: 2.63
 *
 */

"use strict";

window.dzsprx_self_options = {};
window.dzsprx_index = 0;

(function($) {

    $.fn.dzsprs = function(o) {

        var defaults = {
            settings_mode : 'scroll' // scroll or mouse or mouse_body or oneelement

            , js_breakout: 'off' // -- if on it will try to breakout of the container and cover fullwidth,
            ,breakout_fix: 'off' // -- if you are using a div breakout this will add classes and tagnames back

            ,custom_ph:"" // -- in wh or in px
            ,navigation:"none" // -- "none" or "numbers" or "bullets"
        }

        if(typeof o =='undefined'){
            if(typeof $(this).attr('data-options')!='undefined'){
                var aux = $(this).attr('data-options');

                try{
                    var aux_json = JSON.parse(aux);

                    o = $.extend({},aux_json);

                }catch(err){
                    console.error(err);
                }


            }
        }

        o = $.extend(defaults, o);



        Math.easeIn = function(t, b, c, d) {

            return -c *(t/=d)*(t-2) + b;

        };

        Math.easeOutQuad = function (t, b, c, d) {
            t /= d;
            return -c * t*(t-2) + b;
        };
        Math.easeInOutSine = function (t, b, c, d) {
            return -c/2 * (Math.cos(Math.PI*t/d) - 1) + b;
        };



        this.each( function(){
            var cthis = $(this);




            var i =0;

            var tw = 0 // -- target width
                ,th = 0
                ,ch = 0
                ,cw = 0 // -- clip width
                ,ww = 0
                ,wh = 0
                ,ph = 0 // -- page height

                ;



            var st = 0 //--scroll top
                ,vi_y = 0 // -- view index y
                ,bo_o = 0 // -- black offset opacity
                ,cthis_ot  = 0 //--offset top
                ,mt_for_next_element  = 0 //--offset top
                ,mt_for_prev_element  = 0 //--offset top
                ;

            var lazyloading_setsource = '';

            var started = false
                ,debug_var = false
                ;



            var init_delay = 0
                ,init_functional_delay = 0
                ;




            var _pages= null
                ,_pages_clone = null
                ,_pages_scrolling = null
                ,_navigation_con = null
                ,_pages_inner = null
                ,_pages_scrolling_inner = null
            ;

            var sw_is_boxed = false
                ,sw_is_boxed_h = false
                ,sw_is_boxed_v = false
            ;

            var last_st = 0
                ,st = 0
                ,cthis_ol = 0
                ,cthis_pad_top = 0
            ;
            var scroll_direction = 'down';
            var nr_pages = 0;

            var curr_page = -1;

            var inter_clear_transition_out = 0
            ;

            var limit_st_top = 0
                ,limit_st_bot = 0
            ;


            var custom_ph = ''
                ,custom_ph_px = 0
            ; // -- none or "in_px" or "in_pr"


            var _custom_ph_next_element = null
                ,_custom_ph_prev_element = null

            if(init_delay){
                setTimeout(init, init_delay);
            }else{

                init();
            }

            function init(){


                //console.warn('init()',cthis);



                _pages = cthis.find('.parallax-feature-pages').eq(0);
                nr_pages = _pages.children().length;



                wh = window.innerHeight;
                ww = window.innerWidth;

                ph = wh;



                if(is_mobile()){
                    o.custom_ph = '';
                }

                if(cthis.offset().left>10){
                    cthis.addClass('is-boxed');
                    cthis.addClass('is-boxed-h');
                    sw_is_boxed=true;
                    sw_is_boxed_h=true;
                    cthis_ol = cthis.offset().left;
                }

                if(o.custom_ph){

                    cthis.addClass('is-boxed');
                    cthis.addClass('is-boxed-v');

                    sw_is_boxed_v = true;
                    if(String(o.custom_ph).indexOf('%')>-1){

                    }
                    if(String(o.custom_ph).indexOf('px')>-1){
                        custom_ph = 'in_px';

                        //cthis_pad_top = ;
                        custom_ph_px = parseInt(o.custom_ph,10);

                        console.info('cthis_pad_top - ',cthis_pad_top);
                    }

                    if(cthis.next().length){
                        _custom_ph_next_element = cthis.next();

                    }else{
                        if(cthis.parent().next().length){
                            _custom_ph_next_element = cthis.parent().next();
                        }else{
                            if(cthis.parent().parent().next().length){
                                _custom_ph_next_element = cthis.parent().parent().next();
                            }else{
                                if(cthis.parent().parent().parent().next().length){
                                    _custom_ph_next_element = cthis.parent().parent().parent().next();
                                }else{
                                    if(cthis.parent().parent().parent().parent().next().length){
                                        _custom_ph_next_element = cthis.parent().parent().parent().parent().next();
                                    }
                                }
                            }
                        }
                    }
                    if(_custom_ph_next_element){
                        _custom_ph_prev_element = _custom_ph_next_element.prev().prev();
                    }

                    //console.info('cthis.parent().parent().parent() - ',cthis.parent().parent().parent());
                    //console.info('_custom_ph_next_element - ',_custom_ph_next_element);
                    console.info('_custom_ph_prev_element - ',_custom_ph_prev_element);


                }


                cthis.addClass('navigation-'+o.navigation);
                _pages.wrapInner('<div class="pages-inner"></div>');

                _pages_inner = _pages.find('.pages-inner').eq(0);



                if(o.navigation!='none'){
                    _pages.append('<div class="navigation-con"></div>');

                    _navigation_con = cthis.find('.navigation-con');


                    for(var i = 0;i<nr_pages;i++){

                        var aux = '<div class="nav-bullet">';
                        aux+='0'+(i+1);
                        aux+='</div>';
                        _navigation_con.append(aux)
                    }
                }

                var ind  = 0;
                _pages_inner.children().each(function(){
                    var _pag = $(this);

                    _pag.css({
                        'height':'100vh'
                    })


                    _pag.find('.replace-var').each(function(){
                        var _t3 = $(this);

                        _t3.html(String(_t3.html()).replace('{{pagenr}}','0'+(ind+1)));
                    });


                    ind++;
                })

                _pages.after(_pages.clone());
                _pages.after(_pages.clone());


                _pages.next().addClass('cloned-con');
                _pages.next().next().addClass('scrolling-con');

                _pages_clone = _pages.next();
                _pages_scrolling = _pages.next().next();
                _pages_scrolling_inner = _pages_scrolling.find('.pages-inner');



                if(_pages.find('.use-for-scrolling').length){
                    cthis.addClass('has-scrolling-element');


                    _pages_scrolling_inner.children().each(function(){
                        var _t = $(this);
                        //console.warn("WHY");
                        find_scrolling_items_delete_others(_t);
                    });



                }

                cthis.on('click','.nav-bullet',handle_mouse);


                _pages.addClass('fixed-pages');



                cthis.on('click','.custom-parallax-arrow-left,.custom-parallax-arrow-right',handle_mouse)


                $(window).bind('resize',handle_resize);
                handle_resize();

                setTimeout(function(){
                    handle_resize();
                },100);

                $(window).bind('scroll',handle_scroll);

                init_start();
                goto_item(0);

                if(sw_is_boxed_v){
                    if(is_mobile()){
                        handle_frame();
                    }
                }

            }

            function handle_mouse(e){
                var _t = $(this);

                if(_t.hasClass('custom-parallax-arrow-left')){
                    var ind = curr_page-1;

                    if(ind<0){

                        ind = 0;


                    }

                    st = cthis_ot + (ind-1/2)*ph;


                    $(window).scrollTop(st);
                    //window.scrollY = cthis_ot + ind*ph;
                    goto_item(ind);
                }

                if(_t.hasClass('custom-parallax-arrow-right')){
                    var ind = curr_page+1;

                    if(ind>nr_pages-1){

                        ind = nr_pages-1;
                    }

                    st = cthis_ot + (ind-1/2)*ph;

                    $(window).scrollTop(st);
                    //window.scrollY = cthis_ot + ind*ph;
                    goto_item(ind);
                }

                if(_t.hasClass('nav-bullet')){
                    var ind = _t.parent().children().index(_t);

                    if(ind){

                        st = cthis_ot + (ind+1/2)*ph;
                    }else{
                        st = cthis_ot + ph;
                    }

                    $(window).scrollTop(st);
                    //window.scrollY = cthis_ot + ind*ph;
                    goto_item(ind);
                }
            }

            function handle_frame(){
                // -- for mobile;

                calculate_mt()

                requestAnimFrame(handle_frame);
            }

            function find_scrolling_items_delete_others(_arg){

                _arg.children().each(function(){


                    var _t = $(this);

                    //console.info(_t);

                    if(_t.children().length){
                        if(_t.hasClass('use-for-scrolling')==false) {
                            _t.children().each(function () {
                                var _t2 = $(this);

                                if (_t2.hasClass('use-for-scrolling')) {

                                    return false;
                                } else {
                                    if (_t2.hasClass('dzs-container') || _t2.hasClass('dzs-row') || _t2.hasClass('dzs-col-md-6')) {
                                        find_scrolling_items_delete_others(_t2);

                                    } else {

                                        //console.warn("LETS KILL", _t2);
                                        _t2.get(0).outerHTML = (' ');
                                    }
                                }


                            })
                        }
                    }

                })


            }

            function goto_item(arg){


                cthis.removeClass('scroll-direction-up scroll-direction-down');
                cthis.addClass('scroll-direction-'+scroll_direction);
                _pages.removeClass('scroll-direction-up scroll-direction-down');
                _pages.addClass('scroll-direction-'+scroll_direction);

                var last_curr_page = curr_page;



                _pages_inner.children().removeClass('active js-active preparing-transitioning-out transitioning-out');

                setTimeout(function(){

                    if(curr_page>-1){

                        _pages_inner.children().eq(curr_page).removeClass('preparing-transitioning-in transitioning-in');
                        _pages_inner.children().eq(curr_page).addClass('preparing-transitioning-out');
                    }

                    _pages_inner.children().eq(arg).removeClass('preparing-transitioning-out transitioning-out');
                    _pages_inner.children().eq(arg).addClass('active js-active preparing-transitioning-in');


                    if(cthis.hasClass('has-scrolling-element')){
                        _pages_scrolling_inner.children().removeClass('active js-active');
                        _pages_scrolling_inner.children().eq(arg).addClass('active js-active preparing-transitioning-in');
                    }


                    if(_navigation_con){
                        _navigation_con.children().removeClass('active');
                        _navigation_con.children().eq(arg).addClass('active');
                    }



                    var transition_delay =0;

                    //transition_delay =100;
                    //transition_delay =50;
                    transition_delay=150;
                    //transition_delay=450;

                    setTimeout(function(arg1,arg2){
                        do_transition(arg1,arg2);
                    },transition_delay,arg,last_curr_page);


                    curr_page = arg;



                    cthis.find('.custom-parallax-arrow-left,.custom-parallax-arrow-right').removeClass('disabled');

                    if(curr_page==0){
                        cthis.find('.custom-parallax-arrow-left').addClass('disabled');
                    }
                    if(curr_page==nr_pages-1){
                        cthis.find('.custom-parallax-arrow-right').addClass('disabled');
                    }

                },10);


            }

            function do_transition(arg,last_curr_page){


                if(last_curr_page>-1){

                    _pages_inner.children().eq(last_curr_page).addClass('transitioning-out');
                    _pages_inner.children().eq(last_curr_page).removeClass('transitioning-in');
                }


                _pages_inner.children().eq(arg).addClass('transitioning-in');


                if(cthis.hasClass('has-scrolling-element')){
                    _pages_scrolling_inner.children().eq(arg).addClass('transitioning-in');
                }

                if(inter_clear_transition_out){
                    clearTimeout(inter_clear_transition_out);

                }


                var delay_time = 400;

                if(cthis.hasClass('transition-longer-longer-fadeout')){
                    delay_time=2500;
                }
                inter_clear_transition_out = setTimeout(clear_transition_out, delay_time);

            }

            function clear_transition_out(){

                _pages_inner.children().removeClass('preparing-transitioning-out transitioning-out')
            }

            function handle_resize(e,pargs){


                var margs = {
                    'call_from':'default'
                    ,'resize_breakout':true
                    ,'resize_responsive_mode':true
                    ,'resize_fixed_mode':true
                };


                margs = $.extend(margs,pargs);


                wh = window.innerHeight;
                ww = window.innerWidth;

                ph = wh;


                if(custom_ph_px){
                    ph = custom_ph_px;

                    cthis.find('.full-absolute').css({
                        'height':(ph)
                    });
                }


                cthis.find('.h20ph').css({
                    'height':(ph*0.2)
                });
                cthis.find('.h30ph').css({
                    'height':(ph*0.3)
                });
                cthis.find('.h100ph').css({
                    'height':(ph)
                });


                if(margs.resize_breakout){

                    if(o.js_breakout=='on'){
                        cthis.css('width',ww+'px');

                        cthis.css('margin-left','0');

                        //console.info(cthis, cthis.get(0).offsetLeft, cthis.offset().left, _theTarget.offset().left)

                        if(cthis.offset().left>0){
                            cthis.css('margin-left','-'+cthis.offset().left+'px');
                        }
                    }

                }
                //cthis_ol = cthis.offset().left - 15;

                cthis_ot = cthis.offset().top;
                cthis_ol = cthis.offset().left ;

                cw=cthis.width();

                if(started===false){
                    return;
                }


                if(custom_ph=='in_px'){


                    var args_css = {
                        'height':custom_ph_px
                    };
                    cthis.css({
                        'height':(nr_pages) * custom_ph_px
                    })

                    //cthis.css(args_css)
                    _pages.css(args_css)


                    _pages_clone.find('.pages-inner').children().each(function(){
                        var _pag = $(this);

                        _pag.css(args_css)
                    })
                    _pages_inner.children().each(function(){
                        var _pag = $(this);

                        _pag.css(args_css)
                    })

                }

                if(custom_ph){
                    cthis_pad_top = (wh - custom_ph_px) / 2;

                    //console.info('cthis_pad_top - ',cthis_pad_top);
                }

                if(margs.resize_responsive_mode){

                    if(cw<600){
                        cthis.addClass('responsive-mode');
                    }else{

                        cthis.removeClass('responsive-mode');
                    }
                }

                if(margs.resize_fixed_mode){
                    var css_args_v = {
                        'top':''

                    };
                    var css_args_h = {
                        'left':''
                        ,'width':''
                    };

                    //console.warn("check fixed mode from switch");
                    //console.warn("cthis_ol - ",cthis_ol);
                    //console.warn("cthis.hasClass('fixed-mode') - ",cthis.hasClass('fixed-mode'));
                    if(cthis.hasClass('fixed-mode')){


                        if(sw_is_boxed_h){



                            css_args_h = {
                                'left':cthis_ol+'px'
                                ,'width':(_pages_clone.width())+'px'
                            }


                            if(sw_is_boxed_v){

                            }else{

                                _pages.find('.navigation-con').css({

                                    'left':'auto'
                                    ,'right':(cthis_ol+20)+'px'
                                    ,'width':'auto'
                                })
                            }
                        }

                        if(cthis_pad_top){
                            css_args_v ={
                                'top':cthis_pad_top
                            }

                        }
                    }else{

                        _pages.find('.navigation-con').css({

                            'left':''
                            ,'right':''
                            ,'width':''
                        })


                    }
                    _pages.css(css_args_h)
                    _pages.find('.full-absolute > .page-bg').css(css_args_h)


                    if(cthis_pad_top){
                        _pages.css(css_args_v);
                    }
                }






                var i23 = 0;



            }

            function handle_scroll(e){

                st = $(window).scrollTop();
                if(st>last_st){
                    scroll_direction = 'down';
                }else{
                    scroll_direction = 'up';
                }

                //console.info('scroll_direction - ',scroll_direction);


                last_st = st;
                var cto = cthis.offset().top;


                // -- TODO: why does it add 25 ?
                //cto-=25;


                //console.info('st - ',st);
                //console.info('st - cto - ',st - cto);
                //console.info('wh - ',wh);
                //console.info('cto - ',cto);
                //console.info('cto+(nr_pages * wh) - ',cto+(nr_pages * wh));



                var sw_change_fixed = false;


                limit_st_top = cto - cthis_pad_top;
                limit_st_bot = cto +( (nr_pages-1) * ph) - cthis_pad_top;

                if(sw_is_boxed_v){
                    //limit_st_bot-=custom_ph_px;
                }

                if(st > limit_st_top && st<limit_st_bot){

                    if(st<cto+100){
                        if(cthis.hasClass('fixed-mode')){

                        }else{
                            cthis.addClass('disable-opacity-transition-momentarely');
                            setTimeout(function(){

                                cthis.removeClass('disable-opacity-transition-momentarely');
                            },300);


                        }
                    }


                    if(cthis.hasClass('fixed-mode')){

                    }else{

                        sw_change_fixed = true;
                    }

                    cthis.addClass('fixed-mode');


                }else{

                    if(cthis.hasClass('fixed-mode')){

                        if(st> -100 + limit_st_bot){

                            cthis.addClass('exited-from-bottom');
                        }else{

                            cthis.removeClass('exited-from-bottom');
                        }

                        sw_change_fixed = true;

                    }
                    cthis.removeClass('fixed-mode');

                }


                calculate_mt()


                if(sw_change_fixed){

                    handle_resize(null,{
                        'call_from':'default'
                        ,'resize_breakout':false
                        ,'resize_responsive_mode':false
                        ,'resize_fixed_mode':true
                    });
                }


                var temp_page = 0;



                temp_page = Math.floor((st - cto + (ph/2))/ph) ;

                if(temp_page<0){
                    temp_page =0 ;
                }
                if(temp_page>nr_pages-1){
                    temp_page = nr_pages-1 ;
                }

                if(temp_page!=curr_page){
                    goto_item(temp_page);
                }

                //console.info('(st - cto)/wh - ',(st - cto + (ph/2))/ph);
                //console.info('temp_page - ',temp_page);

            }

            function calculate_mt(){
                if(_custom_ph_next_element){

                    mt_for_next_element = ((nr_pages-1) * custom_ph_px);
                    mt_for_prev_element = 0;

                    //mt_for_next_element-=cthis_pad_top;

                    //cthis_ot = cthis.offset().top;

                    console.info('mt_for_next_element - ',mt_for_next_element);
                    //console.info('st - ',st);
                    console.info('st+cthis_pad_top - ',st+cthis_pad_top);
                    console.info('cthis_ot - ',cthis_ot);


                    if(st+cthis_pad_top>cthis_ot){
                        mt_for_next_element-=(st+cthis_pad_top-cthis_ot);

                        mt_for_prev_element = st+cthis_pad_top-cthis_ot;
                    }

                    if(mt_for_next_element>custom_ph_px ){
                        //mt_for_next_element = custom_ph_px ;
                    }



                    if(st+cthis_pad_top>cthis_ot+((nr_pages-1) * custom_ph_px) ){


                        // -- TODO: correct this
                        console.error("HERE WE ")
                        mt_for_prev_element = mt_for_prev_element - (st+cthis_pad_top-(cthis_ot+((nr_pages-1) * custom_ph_px)));
                    }

                    if(mt_for_next_element<0){
                        mt_for_next_element = 0;
                    };


                    _custom_ph_next_element.css({
                        'margin-top':-mt_for_next_element
                    })

                    if(cthis.hasClass('fixed-mode')){

                    }else{

                    }

                    if(mt_for_prev_element){

                        _custom_ph_prev_element.css({
                            'top':mt_for_prev_element
                            ,'z-index':'55'
                        })
                    }else{

                        _custom_ph_prev_element.css({
                            'top':''
                            ,'z-index':''
                        })
                    }
                }
            }

            function init_start() {

                if (started) {
                    return;
                }
                started = true;

                //console.info(is_ie, is_ie(), version_ie(), is_ie11());

            }
        })
    }
    window.dzsprs_init = function(selector, settings) {
        if(typeof(settings)!="undefined" && typeof(settings.init_each)!="undefined" && settings.init_each==true ){
            var element_count = 0;
            for (var e in settings) { element_count++; }
            if(element_count==1){
                settings = undefined;
            }

            $(selector).each(function(){
                var _t = $(this);
                _t.dzsprs(settings)
            });
        }else{
            $(selector).dzsprs(settings);
        }

    };
})(jQuery);

function is_mobile() {
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;

    // Windows Phone must come first because its UA also contains "Android"
    if (/windows phone/i.test(userAgent)) {
        return true;
    }

    if (/android/i.test(userAgent)) {
        return true;
    }

    // iOS detection from: http://stackoverflow.com/a/9039885/177710
    if (/iPad|iPhone|iPod/.test(userAgent) && !window.MSStream) {
        return true;
    }

    return false;
}

function is_touch_device() {
    return !!('ontouchstart' in window);
}

window.requestAnimFrame = (function(){
    return  window.requestAnimationFrame       ||
        window.webkitRequestAnimationFrame ||
        window.mozRequestAnimationFrame    ||
        function( callback ){
            window.setTimeout(callback, 1000 / 60);
        };
})();



function version_ie() {
    return parseFloat(navigator.appVersion.split("MSIE")[1]);
}
;


jQuery(document).ready(function($){


    dzsprs_init('.dzsparallax-showcase.auto-init', {init_each: true});

});